## supercell 2.1.1+~0.0~git20221028.d8eeb73

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6 FATAL_ERROR)

project(supercell)
include(FeatureSummary)

set(CMAKE_CXX_STANDARD 14)

option(BUILD_PROGRAM "Build supercell program" ON)
option(BUILD_DOC "Build supercell manual and tutorial" ON)

if (BUILD_PROGRAM)
  if (CMAKE_BUILD_TYPE STREQUAL "")
    set(CMAKE_BUILD_TYPE Release)
  endif (CMAKE_BUILD_TYPE STREQUAL "")

  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wno-sign-compare -Wextra ")

  option(LINK_STATIC_LIBS "Build project with static libs" OFF)

  if (${CMAKE_COMPILER_IS_GNUCXX})
    if (${LINK_STATIC_LIBS})
      if(NOT WIN32)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc -static-libstdc++ -fuse-ld=gold -Wl,--no-gnu-unique")
      else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc -static-libstdc++ ")
      endif()
      set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
    endif ()
  endif ()

  include_directories(${CMAKE_CURRENT_SOURCE_DIR})
  add_subdirectory(src)

endif (BUILD_PROGRAM)

if(BUILD_DOC)
  add_subdirectory(doc)
endif(BUILD_DOC)

=== doc/CMakeLists.txt ===
add_subdirectory(man)
add_subdirectory(tutorial)

=== src/CMakeLists.txt ===
#set common includes
set(sc_includes
        ${CMAKE_CURRENT_SOURCE_DIR}/core
        ${CMAKE_SOURCE_DIR}/libs/common_utils/
        ${CMAKE_SOURCE_DIR}/3rd_party/gemmi/include
        ${CMAKE_SOURCE_DIR}/3rd_party/xxHash)

#set common sources
file(GLOB core_sources ${CMAKE_CURRENT_SOURCE_DIR}/core/*.cpp)
set(sc_sources ${core_sources}
        ${CMAKE_SOURCE_DIR}/libs/common_utils/others/string_utils.cpp
        ${CMAKE_SOURCE_DIR}/libs/common_utils/cryst_tools/cryst_tools.cpp
        ${CMAKE_SOURCE_DIR}/libs/common_utils/cryst_tools/comb_points.cpp)

add_subdirectory(sc_cli)
add_subdirectory(tests)

=== tests/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/others/)

find_package(Boost 1.46 COMPONENTS unit_test_framework random filesystem system timer)

add_executable(test_str test_str.cpp 
                        ${CMAKE_SOURCE_DIR}/others/string_utils.cpp)
target_link_libraries(test_str ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
add_test(NAME Test_string_utils_module COMMAND test_str)


add_executable(test_expc test_expc.cpp)
target_link_libraries(test_expc ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} quadmath)
add_test(NAME Test_expc_function COMMAND test_expc)

add_executable(test_comb_points test_comb_points.cpp
                        ${CMAKE_SOURCE_DIR}/cryst_tools/comb_points.cpp)
target_link_libraries(test_comb_points ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_RANDOM_LIBRARY})
add_test(NAME Test_Comb_Points COMMAND test_comb_points)

find_package(Eigen3 REQUIRED)
include_directories(${EIGEN3_INCLUDE_DIR})


add_definitions(-DCT_DATA_DIR="${CMAKE_SOURCE_DIR}/tests/data_cryst_tools")



add_executable(test_cryst_tools test_cryst_tools.cpp
                        ${CMAKE_SOURCE_DIR}/cryst_tools/comb_points.cpp
                        ${CMAKE_SOURCE_DIR}/cryst_tools/cryst_tools.cpp)
target_link_libraries(test_cryst_tools ${Boost_LIBRARIES} PkgConfig::libOB)
add_test(NAME Test_Cryst_Tools COMMAND test_cryst_tools)


add_executable(test_combinatorics test_combinatorics.cpp)
target_link_libraries(test_combinatorics ${Boost_LIBRARIES})
add_test(NAME Test_Combinatorics COMMAND test_combinatorics)

=== doc/man/CMakeLists.txt ===
find_package(Perl)
if(PERL_FOUND)
  add_custom_command(OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/supercell.1
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/latex2man/latex2man 
                             ${CMAKE_CURRENT_SOURCE_DIR}/supercell_man.tex
                             ${CMAKE_CURRENT_BINARY_DIR}/supercell.1
                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/supercell_man.tex
                             ${CMAKE_SOURCE_DIR}/scripts/latex2man/latex2man)
  add_custom_target(doc_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/supercell.1)
  set(man_1 ${CMAKE_CURRENT_BINARY_DIR}/supercell.1)

  add_custom_command(OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/supercell_man.html
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/latex2man/latex2man -H -c supercell_man.css
                             ${CMAKE_CURRENT_SOURCE_DIR}/supercell_man.tex
                             ${CMAKE_CURRENT_BINARY_DIR}/supercell_man.html
                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/supercell_man.tex
                             ${CMAKE_SOURCE_DIR}/scripts/latex2man/latex2man)
  add_custom_target(doc_html ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/supercell_man.html)
else(PERL_FOUND)
  message(WARNING "Perl is not found. Documentation (Unix man) will be not created")
  set(man_1 ${CMAKE_CURRENT_SOURCE_DIR}/supercell.1)
endif(PERL_FOUND)

find_package(LATEX COMPONENTS PDFLATEX)
if(PDFLATEX_COMPILER)
  add_custom_command(OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/supercell_man.pdf
                     COMMAND ${PDFLATEX_COMPILER} -interaction=batchmode 
                             "\"\\input{${CMAKE_CURRENT_SOURCE_DIR}/supercell_man.tex}\""
                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/supercell_man.tex)
                       
  add_custom_target(doc_pdf ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/supercell_man.pdf)
else()
  message(WARNING "LATEX is not found. PDF manual will be not created")
endif()

install(FILES ${man_1} DESTINATION share/man/man1)

=== doc/tutorial/CMakeLists.txt ===
find_package(LATEX COMPONENTS PDFLATEX)
find_program(PYGMENTIZE_CMD NAMES pygmentize)
if(PDFLATEX_COMPILER)
  if(PYGMENTIZE_CMD)
    configure_file(supercell_tutorial.tex supercell_tutorial.tex COPYONLY)
    configure_file(supercell_tutorial.bib supercell_tutorial.bib COPYONLY)
    configure_file(figures/ice-Ih-121-adv.png figures/ice-Ih-121-adv.png COPYONLY)
    #configure_file(figures/ndss-transf.png figures/ndss-transf.png COPYONLY)

    add_custom_command(OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/supercell_tutorial.pdf
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/latex_compile.sh supercell_tutorial
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/supercell_tutorial.tex
                               ${CMAKE_CURRENT_SOURCE_DIR}/supercell_tutorial.bib
                               ${CMAKE_CURRENT_SOURCE_DIR}/figures/ice-Ih-121-adv.png)
                      
    add_custom_target(tutorial_pdf ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/supercell_tutorial.pdf)
  else()
    message(WARNING "Pygmentize is not found. PDF tutorial will be not created")
  endif()
else()
  message(WARNING "LATEX is not found. PDF tutorial will be not created")
endif()

=== src/sc_cli/CMakeLists.txt ===
set(Boost_USE_STATIC_LIBS ${LINK_STATIC_LIBS})
find_package(Boost 1.63 REQUIRED COMPONENTS program_options filesystem system)
include_directories(${Boost_INCLUDE_DIRS})

find_package(PkgConfig)

find_package(Threads REQUIRED)

find_package(Eigen3 REQUIRED)
add_definitions     ( ${EIGEN3_DEFINITIONS} )
include_directories ( ${EIGEN3_INCLUDE_DIRS} )

find_package(TBB COMPONENTS tbb)
if( NOT ${TBB_FOUND} )
    set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${PROJECT_SOURCE_DIR}/3rd_party/cmake/")
    find_package(TBB COMPONENTS tbb)
    if( NOT ${TBB_FOUND} )
        find_package(PkgConfig REQUIRED)
        pkg_search_module(PKGTBB REQUIRED IMPORTED_TARGET intel-tbb tbb)
        add_library(TBB::tbb ALIAS PkgConfig::PKGTBB)
    else()
        find_package(TBB REQUIRED COMPONENTS tbb)
    endif()
endif()

if( TBB_FOUND AND LINK_STATIC_LIBS )
    get_property(pmt TARGET TBB::tbb PROPERTY IMPORTED_LOCATION_RELEASE)
    string(REGEX REPLACE "libtbb\.(so|dylib)" "libtbb_static.a" pmt ${pmt})
    set_property(TARGET TBB::tbb PROPERTY IMPORTED_LOCATION_RELEASE ${pmt})
endif()

if (NOT TBB_USE_GLIBCXX_VERSION AND UNIX AND NOT APPLE)
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        # using Clang
        string(REPLACE "." "0" TBB_USE_GLIBCXX_VERSION ${CMAKE_CXX_COMPILER_VERSION})
    endif()
endif()

if (TBB_USE_GLIBCXX_VERSION)
    add_definitions(-DTBB_USE_GLIBCXX_VERSION=${TBB_USE_GLIBCXX_VERSION})
endif()

find_package(LibArchive)
if( ${LibArchive_FOUND} )
    set(sc_includes ${sc_includes} ${LibArchive_INCLUDE_DIRS})
    add_definitions(-DLIBARCHIVE_ENABLED)
    set(CMAKE_REQUIRED_INCLUDES ${LibArchive_INCLUDE_DIRS})
    if(LINK_STATIC_LIBS)
        find_package(BZip2 REQUIRED)
        find_package(LibLZMA REQUIRED)
        find_package(ZLIB REQUIRED)
        set(LibArchive_LIBRARIES ${LibArchive_LIBRARIES} ${LIBLZMA_LIBRARIES} ${BZIP2_LIBRARIES} ${ZLIB_LIBRARIES})
    endif()
else()
    message(WARNING "libarchive is not found. Packed output will be disabled.")
endif()

include_directories(${sc_includes})
add_executable(supercell ${sc_sources} main.cpp parse_d2o_input.cpp)
target_link_libraries(supercell Boost::program_options Boost::filesystem Boost::system
        ${LibArchive_LIBRARIES} TBB::tbb Threads::Threads )

install(TARGETS supercell RUNTIME DESTINATION bin)

=== src/tests/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/others/)

find_package(Boost 1.46 REQUIRED COMPONENTS unit_test_framework)

find_package(Eigen3 REQUIRED)
add_definitions     ( ${EIGEN3_DEFINITIONS} )
include_directories ( ${EIGEN3_INCLUDE_DIRS} )

if(Boost_FOUND)
    add_executable(test_random_sampler ${CMAKE_SOURCE_DIR}/src/core/common_types.cpp test_random_sampler.cpp)
    target_link_libraries(test_random_sampler Boost::unit_test_framework)
    add_test(NAME TestRandomSampler COMMAND test_random_sampler)
endif()

#add_subdirectory(regression)

=== debian/changelog ===
supercell (2.1.1+~0.0~git20221028.d8eeb73-2) unstable; urgency=medium

  * Replace gemmi-dev with libgemmi-dev.

 -- Andrius Merkys <merkys@debian.org>  Thu, 12 Feb 2026 03:28:52 -0500

supercell (2.1.1+~0.0~git20221028.d8eeb73-1) unstable; urgency=medium

  * Initial release (Closes: #1118057)

 -- Andrius Merkys <merkys@debian.org>  Wed, 15 Oct 2025 08:40:59 -0400

=== debian/control ===
Source: supercell
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 gemmi,
 libarchive-dev,
 libboost-program-options-dev,
 libboost-filesystem-dev,
 libboost-test-dev,
 libeigen3-dev,
 libgemmi-dev,
 libtbb-dev,
 pkgconf,
Standards-Version: 4.7.2
Homepage: https://github.com/orex/supercell
Vcs-Browser: https://salsa.debian.org/debichem-team/supercell
Vcs-Git: https://salsa.debian.org/debichem-team/supercell.git

Package: supercell
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: structure generation for crystals with substitutions and partial occupancies
 supercell is a combinatorial structure-generation approach for the local-level
 modeling of atomic substitutions and partial occupancies in crystals. It uses
 supercell approximation and enumeration algorithm to convert structures with
 vacancies and/or substitution to "binary" occupied. The program mostly uses to
 prepare DFT calculations of battery matrials, semiconductors etc.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_before_dh_auto_configure:
	mkdir libs
	ln -s ../common-utils libs/common_utils

execute_before_dh_auto_clean:
	rm -rf libs

=== debian/watch ===
Version: 5
Version-Schema: group

Template: Github
Owner: orex
Project: supercell

Component: common_utils
Source: https://github.com/orex/common_utils
Matching-Pattern: HEAD
Mode: git

## supercell core-0.1.7

=== docs/requirements.txt ===
sphinx>=2.2.0
sphinx_rtd_theme
m2r

## supercell step-2021.2.12

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/supercell_step.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/supercell_step.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/supercell_step"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/supercell_step"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."
